/**
 * Your Copyright Here
 *
 * Appcelerator Titanium is Copyright (c) 2009-2010 by Appcelerator, Inc.
 * and licensed under the Apache Public License (version 2)
 */
#import "ComAppceleratorTimeModule.h"
#import "TiBase.h"
#import "TiHost.h"
#import "TiUtils.h"
#import <UIKit/UIKit.h>
#import <Foundation/NSProcessInfo.h>


@implementation ComAppceleratorTimeModule

#pragma mark Internal

// this is generated for your module, please do not change it
-(id)moduleGUID
{
	return @"18ebbf90-3bef-47f0-be80-b8048f999dc3";
}

// this is generated for your module, please do not change it
-(NSString*)moduleId
{
	return @"com.appcelerator.time";
}

#pragma mark Lifecycle

-(void)startup
{
	// this method is called when the module is first loaded
	// you *must* call the superclass
	[super startup];
	
	NSLog(@"[INFO] %@ loaded",self);
}

-(void)shutdown:(id)sender
{
	// this method is called when the module is being unloaded
	// typically this is during shutdown. make sure you don't do too
	// much processing here or the app will be quit forceably
	
	// you *must* call the superclass
	[super shutdown:sender];
}

#pragma mark Cleanup 

-(void)dealloc
{
	// release any resources that have been retained by the module
	[super dealloc];
}

#pragma mark Internal Memory Management

-(void)didReceiveMemoryWarning:(NSNotification*)notification
{
	// optionally release any resources that can be dynamically
	// reloaded once memory is available - such as caches
	[super didReceiveMemoryWarning:notification];
}

#pragma mark Listener Notifications

NSString * TiLargeTimeJump = @"largeTimeJump";

-(void)fireLargeTimeJump:(NSNotification *)notification
{
	[self fireEvent:TiLargeTimeJump withObject:nil];
}

-(void)_listenerAdded:(NSString *)type count:(int)count
{
	if (count == 1 && [type isEqualToString:TiLargeTimeJump])
	{
		TiThreadPerformOnMainThread(^{
			[[NSNotificationCenter defaultCenter] addObserver:self
					selector:@selector(fireLargeTimeJump:)
					name:UIApplicationSignificantTimeChangeNotification
					object:nil];
		},YES);
	}
}

-(void)_listenerRemoved:(NSString *)type count:(int)count
{
	if (count == 0 && [type isEqualToString:TiLargeTimeJump])
	{
		TiThreadPerformOnMainThread(^{
			[[NSNotificationCenter defaultCenter] removeObserver:self
					name:UIApplicationSignificantTimeChangeNotification
					object:nil];
		},YES);
	}
}

#pragma Public APIs

-(id)systemBootTime
{
	return [NSDate dateWithTimeIntervalSinceNow:-[[NSProcessInfo processInfo] systemUptime]];
}

-(id)systemUpTime
{
	return [NSNumber numberWithFloat:[[NSProcessInfo processInfo] systemUptime]*1000.0];
}

@end
